%define module_name	fglrx
%define module_version	8.18.6
%define module_release	alt1.132122.13.1

%define kversion	2.4.26
%define krelease	alt13.1
%define flavour		vs-smp

%define module_dir /lib/modules/%kversion-%flavour-%krelease/%module_name


Summary:	ATI video card drivers
Name:		kernel-modules-%module_name-%flavour
Version:	1.0.%module_version
Release:	%module_release
License:	Proprietary
Group:		System/Kernel and hardware

Packager:       Kernel Maintainer Team <kernel@packages.altlinux.org>

ExclusiveOS:	Linux
URL:		http://www.schneider-digital.de/html/body_download_ati.html
BuildRequires: kernel-build-tools >= 0.7
BuildRequires: kernel-headers-modules-%flavour = %kversion-%krelease
BuildRequires: kernel-headers-%flavour = %kversion-%krelease
BuildRequires: kernel-source-%module_name-%module_version

Provides:  kernel-modules-%module_name-%kversion-%flavour-%krelease = %version-%release
Conflicts: kernel-modules-%module_name-%kversion-%flavour-%krelease < %version-%release
Conflicts: kernel-modules-%module_name-%kversion-%flavour-%krelease > %version-%release

Prereq:		coreutils
Prereq:		modutils
Prereq:         kernel-image-%flavour = %kversion-%krelease
Requires(postun): kernel-image-%flavour = %kversion-%krelease

ExclusiveArch:	%ix86

%description
Drivers for Linux Fire GL X1/Z1/E1/8800/8700/9000/9700/9800 RADEON 
for Xfree86 4.3.x.

%prep
rm -rf kernel-source-%module_name-%module_version
tar -jxvf %kernel_src/kernel-source-%module_name-%module_version.tar.bz2
%setup -D -T -n kernel-source-%module_name-%module_version

%build

. %_usrsrc/linux-%kversion-%flavour/gcc_version.inc

%if "%kversion" < "2.6.0"

#build for 2.4 kernel
if grep -qs '#define.*CONFIG_SMP.*1' %_includedir/linux-%kversion-%flavour/include/linux/autoconf.h ; then
	def_smp="-D__SMP__"
else
	def_smp=""
fi

%define fglrx_gcc gcc -Wall -Wwrite-strings -Wpointer-arith -Wcast-align -Wstrict-prototypes -Wpointer-arith -O2  -D__KERNEL__ -DMODULE -DMODVERSIONS -fomit-frame-pointer -DATI_AGP_HOOK -DATI -DFGL -DFGL_CUSTOM_MODULE -D__AGP__ -DPAGE_ATTR_FIX=1 -I. -I%_includedir/linux-%kversion-%flavour/include -include %_includedir/linux-%kversion-%flavour/include/linux/modversions.h $def_smp

%fglrx_gcc -c agpgart_be.c -o agpgart_be.o
%fglrx_gcc -c nvidia-agp.c -o nvidia-agp.o
%fglrx_gcc -c agp3.c -o agp3.o
%fglrx_gcc -c i7505-agp.c -o i7505-agp.o
%fglrx_gcc -c firegl_public.c -o firegl_public.o
ld -r firegl_public.o agpgart_be.o agp3.o i7505-agp.o nvidia-agp.o \
    libfglrx_ip.a.GCC%__gcc_version_major -o fglrx.o

%else

#build for 2.6 kernel

%__ln_s ./2.6.x/Makefile ./Makefile
%make_build TEMP_DIR=$PWD/ -C %_usrsrc/linux-%kversion-%flavour modules \
	SUBDIRS=$PWD GCC_VER_MAJ=`echo "$GCC_VERSION" | sed 's/^\([0-9]\+\).*/\1/'`

%endif

%install
mkdir -p $RPM_BUILD_ROOT/%module_dir
%if "%kversion" < "2.6.0"
install -p -m644 fglrx.o $RPM_BUILD_ROOT/%module_dir
%else
install -p -m644 fglrx.ko $RPM_BUILD_ROOT/%module_dir
%endif

%post
%post_kernel_modules %kversion-%flavour-%krelease

%postun
%postun_kernel_modules %kversion-%flavour-%krelease

%files
%defattr(644,root,root,755)
%module_dir

%changelog
* Sun Oct 16 2005 LAKostis <lakostis at altlinux.ru> 1.0.8.18.6-alt1.132122.13.1
- Version 8.18.6.
- special build for Master-2.4.
- remove obsoleted patches.

* Sat Jul 02 2005 Sergey Vlasov <vsu@altlinux.ru> 1.0.8.14.13-alt2.132122.13.1
- Added patches to fix build with kernel 2.6.12:
  + 01_fglrx-2.6.12-pci_name.patch: use pci_name(dev) instead of dev->slot_name
    to fix compilation with kernel 2.6.12
  + 02_fglrx-2.6.12-inter_module.patch: inter_module_get() is no longer
    available in kernel 2.6.12 - avoid using it
  + 03_fglrx-8.14.13-alt-2.6.12-agp.patch: add wrappers for new agpgart
    interfaces in kernel 2.6.12 (should work for systems with a single AGP
    bridge, proper solution requires new interfaces with the binary-only part)
  + 04_fglrx-8.14.13-alt-nopage-proto.patch: fix wrong arguments for
    vm_pcie_nopage() implementation for 2.6.x

* Sun Jun 12 2005 Sergey Vlasov <vsu@altlinux.ru> 1.0.8.14.13-alt1.132122.13.1
- Version 8.14.13.

* Wed Jun 01 2005 Sergey Vlasov <vsu@altlinux.ru> 1.0.8.12.10-alt1.132122.13.1
- Version 8.12.10.

* Mon Mar 14 2005 Sergey Vlasov <vsu@altlinux.ru> 1.0.8.10.19-alt1.132122.13.1
- Version 8.10.19 for X.Org 6.8.

* Sun Jan 30 2005 Sergey Vlasov <vsu@altlinux.ru> 1.0.8.8.25-alt1.132122.13.1
- Version 8.8.25 for X.Org 6.8.
- Removed all patches (moved to kernel-source-fglrx).

* Sun Dec 26 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.11.1-alt3.132122.13.1
- Rebuild for kernel 2.4.28.

* Sun Oct 17 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.11.1-alt2.132122.13.1
- Rebuild for kernel 2.4.27.

* Mon Aug 16 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.11.1-alt1.132122.13.1
- Version 3.11.1.
- Removed patches:
  - fglrx-3.2.5-agp-i875.patch (fixed upstream)
  - fglrx-3.7.6-page-count.patch (fixed upstream)

* Tue Aug 03 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.7.6-alt6.132122.13.1
- Use %%post_kernel_modules and %%postun_kernel_modules macros in scripts.

* Wed Jun 23 2004 Anton Farygin <rider@altlinux.ru> 1.0.3.7.6-alt5.132122.13.1
- fglrx-3.7.6-page-count.patch:
    * fixed build problem for 2.6.7 kernel

* Thu May 13 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.7.6-alt4.132122.13.1
- Rebuild for kernel 2.4.26.

* Wed May 12 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.7.6-alt3.132122.13.1
- Added Patch6: fglrx-3.7.6-sis-agp3-support.patch: AGP3 support for SiS 648.

* Mon Apr 12 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.7.6-alt2.132122.13.1
- Added Patch5: fglrx-3.7.6-agp-sis-fix.patch: workaround for SiS 648 and 746
  chips (seems that they need a delay after setting AGP rate).

* Mon Mar 22 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.7.6-alt1.132122.13.1
- Version 3.7.6.

* Fri Feb 27 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.7.0-alt4.132122.13.1
- Updated for the new compiler version selection scheme (GCC_VERSION).

* Wed Feb 18 2004 Anton Farygin <rider@altlinux.ru> 1.0.3.7.0-alt3.132122.13.1
- rebuild for 2.6.3

* Mon Feb 16 2004 Anton Farygin <rider@altlinux.ru> 1.0.3.7.0-alt2.132122.13.1
- build for kernel 2.6

* Sun Jan 04 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.7.0-alt1.132122.13.1
- Version 3.7.0.
- Fixed SMP build options (-D__SMP__ is required for SMP kernels).
- Fixed PAGE_ATTR_FIX typo in compilation options.

* Fri Nov 28 2003 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.2.8-alt3.132122.13.1
- Added Provides/Conflicts to make sure that only one version of the package
  can be installed for each kernel version.

* Tue Nov 18 2003 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.2.8-alt2.132122.13.1
- Fixed spec file name.
- Avoid %%postun failure when this package is removed after
  kernel-image-%%flavour (currently rpm cannot prevent this).
- Added Patch4: fglrx-3.2.8-nvidia-nforce.patch: fixed nForce AGP support.

* Sun Oct 12 2003 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.2.8-alt1.132122.13.1
- new version (3.2.8).
- updated Patch1 (some SiS support was added in upstream, only SiS 745 remains
  unknown).
- fixed compile flags.
- Patch3: fixed AGP 2.0 support for VIA KT400 and P4X333.

* Mon Sep 29 2003 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.2.5-alt16.132122.13.1
- Patch2: fixed Intel 875P chipset support (it does not have integrated
  graphics capability).

* Fri Sep 26 2003 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.2.5-alt15.132122.13.1
- replaced %%{_usrsrc}/kernel/sources with %%kernel_src
- Patch1: added new SiS host bridge IDs to the builtin AGP support (from
  mainstream kernel)

* Mon Sep 08 2003 Anton Farygin <rider@altlinux.ru> 1.0.3.2.5-alt14.132122.13.1
- new version (3.2.5)

* Wed Sep 03 2003 Rider <rider@altlinux.ru> 1.0.2.9.12-alt14.132122.13.1
- replace /usr/include to _includedir macro

* Tue Aug 26 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt13
- rebuilt with 2.4.21rel-alt14

* Fri Aug 15 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt12
- rebuilt with 2.4.21rel-alt13

* Wed Aug 13 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt11
- rebuilt with 2.4.21rel-alt12

* Tue Aug 12 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt10
- rebuilt with 2.4.21rel-alt11

* Mon Aug 11 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt9
- rebuilt with 2.4.21rel-alt10

* Thu Aug 07 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt8
- rebuilt with 2.4.21rel-alt9

* Wed Aug 06 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt7
- rebuilt with 2.4.21rel-alt8

* Wed Jul 30 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt6
- rebuilt with 2.4.21rel-alt7

* Thu Jul 17 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt5
- rebuilt with 2.4.21rel-alt6

* Wed Jul 16 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt4
- rebuilt with 2.4.21rel-alt5

* Tue Jul 08 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt3
- added -include /usr/include/linux-%{kversion}-%{flavour}/include/linux/modversions.h
  now it actually WORKS!

* Sat Jun 21 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt2
- rebuilt with 2.4.21rel kernel

* Thu Jun 05 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt1
- initial version.

